local a=require"luci.util"
local t=require"luci.http"
local e=require"luci.model.docker"
local i=require"luci.iform"
module("luci.controller.ubuntu",package.seeall)
function index()
entry({"admin","services","ubuntu"},call("redirect_index"),_("Ubuntu"),30).dependent=true
entry({"admin","services","ubuntu","pages"},call("ubuntu_index")).leaf=true
entry({"admin","services","ubuntu","form"},call("ubuntu_form"))
entry({"admin","services","ubuntu","submit"},call("ubuntu_submit"))
end
local e="ubuntu"
local o={"admin","services","ubuntu","pages"}
function redirect_index()
t.redirect(luci.dispatcher.build_url(unpack(o)))
end
function ubuntu_index()
luci.template.render("ubuntu/main",{prefix=luci.dispatcher.build_url(unpack(o))})
end
function ubuntu_form()
local i=""
local a=""
local o=0
local e=get_data()
local e={
data=e,
schema=get_schema(e)
}
local e={
error=i,
scope=a,
success=o,
result=e,
}
t.prepare_content("application/json")
t.write_json(e)
end
function get_schema(t)
local e
if t.container_install then
e={
{
name="restart",
text="重启",
type="apply",
},
{
name="upgrade",
text="更新",
type="apply",
},
{
name="remove",
text="删除",
type="apply",
},
}
else
e={
{
name="install",
text="安装",
type="apply",
},
}
end
local e={
actions=e,
containers=get_containers(t),
description="带 Web 远程桌面的 Docker 高性能版 Ubuntu。默认<用户名:kasm_user 密码:password> 访问官网 <a href=\"https://www.kasmweb.com/\" target=\"_blank\">https://www.kasmweb.com/</a>",
title="Ubuntu"
}
return e
end
function get_containers(e)
local e={
status_container(e),
main_container(e)
}
return e
end
function status_container(t)
local e
if t.container_install then
e="Ubuntu 运行中"
else
e="Ubuntu 未运行"
end
local e={
labels={
{
key="状态：",
value=e
},
{
key="访问：",
value=""
}
},
description="访问链接是一个自签名的 https，需要浏览器同意才能访问！",
title="服务状态"
}
return e
end
function main_container(e)
local e={
properties={
{
name="port",
required=true,
title="端口",
type="string"
},
{
name="password",
required=true,
title="密码",
type="string"
},
{
name="version",
required=true,
title="安装版本",
type="string",
enum={"standard","full"},
enumNames={"Standard Version","Full Version"}
},
},
description="请选择合适的版本进行安装：",
title="服务操作"
}
return e
end
function get_data()
local t=require"luci.model.uci".cursor()
local o=a.exec("which docker")
local o=(string.len(o)>0)
local a=a.trim(a.exec("docker ps -qf 'name="..e.."'"))
local o=(string.len(a)>0)
local a=tonumber(t:get_first(e,e,"port","6901"))
local e={
port=a,
user_name="kasm_user",
password=t:get_first(e,e,"password",""),
version=t:get_first(e,e,"version","standard"),
container_install=o
}
return e
end
function ubuntu_submit()
local s=""
local n=""
local o=0
local a
local e=require"luci.jsonc"
local e=e.parse
local i=t.content()
local e=e(i)
if e["$apply"]=="upgrade"then
a=install_upgrade_ubuntu(e)
elseif e["$apply"]=="install"then
a=install_upgrade_ubuntu(e)
elseif e["$apply"]=="restart"then
a=restart_ubuntu(e)
else
a=delete_ubuntu()
end
t.prepare_content("application/json")
local e={
error=s,
scope=n,
success=o,
result=a,
}
t.write_json(e)
end
function install_upgrade_ubuntu(t)
local i=t["password"]
local o=t["port"]
local n=t["version"]
local a=require"luci.model.uci".cursor()
a:tset(e,"@"..e.."[0]",{
password=i or"password",
port=o or"6901",
version=n or"standard",
})
a:save(e)
a:commit(e)
local t=string.format("/usr/libexec/istorec/ubuntu.sh %s",t["$apply"])
t="/etc/init.d/tasks task_add ubuntu "..luci.util.shellquote(t)
os.execute(t.." >/dev/null 2>&1")
local e={
async=true,
async_state=e
}
return e
end
function delete_ubuntu()
local e=i.exec_to_log("docker rm -f ubuntu")
local e={
async=false,
log=e
}
return e
end
function restart_ubuntu()
local e=i.exec_to_log("docker restart ubuntu")
local e={
async=false,
log=e
}
return e
end
